/**
 *  Packet.h
 *  server
 *
 *  $LastChangedBy: jch231 $
 *  $Date: 2010-08-19 11:35:17 +1200 (Thu, 19 Aug 2010) $
 *
 */

#ifndef PACKET_H
#define PACKET_H

#include "TypeDef.h"

/** Valid commands to send to the server */
enum Command {LOGIN, LOGOUT, STARTCHAT, LEAVECHAT, SEND, INVITE, LOGINFAILED, 
              LOGINSUCCESS, ADDUSER, REMOVEUSER};

/**
 *  A data container for transactions with the server.
 */
class Packet {
public:
  Packet(Command command) : 
  command_(command), 
  chat_("-"), 
  sender_("-"), 
  target_("-") {
    message_.user = "-";
    message_.text = "-";
  }
  ~Packet() {}
  
  Command command() {return command_;}
  
  void chat(ChatID chat) {chat_ = chat;}
  ChatID chat() {return chat_;}
  
  void sender(UserID sender) {sender_ = sender;}
  UserID sender() {return sender_;}
  
  void target(UserID target) {target_ = target;}
  UserID target() {return target_;}
  
  void message(Message message) {message_ = message;}
  Message message() {return message_;}
  
private:
  Command command_;
  ChatID chat_;
  UserID sender_;
  UserID target_;
  Message message_;
};

#endif /* PACKET_H */