/**
 *  \file Subject.cpp
 *  \brief Implementation of the Subject class that implments the subject
 *  from the GOF Observer Design Pattern.
 *
 *  $LastChangedBy: jch231 $
 *  $Date: 2010-08-19 11:35:17 +1200 (Thu, 19 Aug 2010) $
 *
 */

#include "Subject.h"

void Subject::Register(Observer* observer) {
  //Register the observer by adding it to the list.
  observers.insert(observer);
}

void Subject::Deregister(Observer* observer) {
  observers.erase(observer);
}

void Subject::Notify() {
  //Update each observer
  Observers::iterator it;
  for (it = observers.begin(); it != observers.end(); ++it) {
    (*it)->Update(this);
  }
}
