/**
 *  \file  client/UserManager.h
 *  \brief Implementation of a user manager
 *
 *  $LastChangedBy: sjk114 $
 *  $Date: 2010-08-19 16:09:10 +1200 (Thu, 19 Aug 2010) $
 *
 */

#include "UserList.h"
#include <iostream>

UserList::UserList(Outbox* outbox){
  outbox_ = outbox;
}

void UserList::Add(UserID user) {
  mutex_.Lock();
  users_.insert(user);
  mutex_.Unlock();
  Notify();
}

void UserList::Remove(UserID user) {
  mutex_.Lock();
  users_.erase(user);
  mutex_.Unlock();
  Notify();
}

Users const UserList::users() {
  //ScopedLock(&mutex_);
  return users_;
}
