/**
 *  \file  ListenerSocket.h
 *  \brief The declaration of a socket to listen for incoming connections
 *         from clients.
 *
 *  $LastChangedBy: jch231 $
 *  $Date: 2010-08-19 14:34:07 +1200 (Thu, 19 Aug 2010) $
 *
 */

#ifndef LISTENER_SOCKET_H
#define LISTENER_SOCKET_H

#include "Thread.h"
#include "TypeDef.h"

class Server;

/**
 *  \class ListenerSocket
 *  \brief A thread that listens for incoming client connections on a socket. 
 */
class ListenerSocket : public Thread {
public:
  /**
   *  \brief Constructor
   *  \param server a pointer to a Server object
   */
  ListenerSocket(Server* server);
  
  /**
   *  \brief Destructor
   */
  ~ListenerSocket();
  
  /**
   *  \brief Threaded task.
   */
  virtual void Run();
  
private:
  
  int sock;                       ///< The socket file descriptor
  Server* server_;
};

#endif /* LISTENER_SOCKET_H */
