/**
 *  \file Server.cpp
 *
 *  $LastChangedBy: sjk114 $
 *  $Date: 2010-08-19 16:35:44 +1200 (Thu, 19 Aug 2010) $
 *
 */

#include "Server.h"

Server::Server()
: chat_manager(&user_manager), 
  user_manager(), 
  listener_socket(this) {
  listener_socket.Run();
}

void Server::newConnection(int connection_id) {
  ServerSocket* socket = new ServerSocket(connection_id);
  Outbox* send = new Outbox(socket);
  Inbox* inbox = new Inbox(socket, send, &user_manager, &chat_manager);
  inbox->Start();
  clients.push_back(inbox);
}