/**
 *  \file ServerSocket.h
 *  \brief The server-side socket wrapper for communicating with a single client
 *
 *  $LastChangedBy: sjk114 $
 *  $Date: 2010-08-19 14:20:48 +1200 (Thu, 19 Aug 2010) $
 *
 */

#ifndef SERVER_SOCKET_H
#define SERVER_SOCKET_H

#include "Socket.h"

/**
 *  \class ServerSocket
 *  \brief The server-side socket wrapper for communicating with a single client
 */
class ServerSocket : public Socket {
public:
  /**
   *  \brief Store the socket file descriptor
   *  \param socket_fd the socket file descriptor
   */
  ServerSocket(int socket_fd) { 
    sock = socket_fd;
  }
};

#endif /* SERVER_SOCKET_H */
